class USW_Uzi extends UniversalSoldiersWeapon;

#exec MESH IMPORT MESH=mac ANIVFILE=MODELS\mac_a.3D DATAFILE=MODELS\mac_d.3D X=0 Y=0 Z=0 
#exec MESH ORIGIN MESH=mac X=0 Y=0 Z=0 YAW=0 PITCH=0 ROLL=0
#exec MESH SEQUENCE MESH=mac SEQ=All     STARTFRAME=0   NUMFRAMES=56
#exec MESH SEQUENCE MESH=mac SEQ=Select  STARTFRAME=0   NUMFRAMES=11 RATE=20 GROUP=Select
#exec MESH SEQUENCE MESH=mac SEQ=Still   STARTFRAME=10  NUMFRAMES=1
#exec MESH SEQUENCE MESH=mac SEQ=Fire  STARTFRAME=22  NUMFRAMES=3
#exec MESH SEQUENCE MESH=mac SEQ=Reloaded  STARTFRAME=25  NUMFRAMES=30 RATE=10
#exec MESH SEQUENCE MESH=mac SEQ=Down    STARTFRAME=11  NUMFRAMES=11


#exec TEXTURE IMPORT NAME=mac_t1 FILE=Textures\mac_t1.bmp GROUP=Skins FLAGS=2
#exec TEXTURE IMPORT NAME=mac_t2 FILE=Textures\mac_t2.bmp GROUP=Skins FLAGS=2
#exec TEXTURE IMPORT NAME=AddHand FILE=Textures\AddHand0.bmp GROUP=Skins FLAGS=2

#exec MESHMAP SCALE MESHMAP=mac X=0.1 Y=0.08 Z=0.2

#exec MESHMAP SETTEXTURE MESHMAP=mac NUM=3 TEXTURE=AddHand
#exec MESHMAP SETTEXTURE MESHMAP=mac NUM=2 TEXTURE=AddHand
#exec MESHMAP SETTEXTURE MESHMAP=mac NUM=1 TEXTURE=mac_t2
#exec MESHMAP SETTEXTURE MESHMAP=mac NUM=0 TEXTURE=mac_t1


#exec MESH IMPORT MESH=macL ANIVFILE=MODELS\macL_a.3D DATAFILE=MODELS\macL_d.3D X=0 Y=0 Z=0 Unmirror=1
#exec MESH ORIGIN MESH=macL X=0 Y=0 Z=0 YAW=0 PITCH=0 ROLL=0
#exec MESH SEQUENCE MESH=macL SEQ=All     STARTFRAME=0   NUMFRAMES=56
#exec MESH SEQUENCE MESH=macL SEQ=Select  STARTFRAME=0   NUMFRAMES=11 RATE=20 GROUP=Select
#exec MESH SEQUENCE MESH=macL SEQ=Still   STARTFRAME=10  NUMFRAMES=1
#exec MESH SEQUENCE MESH=macL SEQ=Fire    STARTFRAME=22  NUMFRAMES=3
#exec MESH SEQUENCE MESH=macL SEQ=Reloaded  STARTFRAME=25  NUMFRAMES=30 RATE=10
#exec MESH SEQUENCE MESH=macL SEQ=Down    STARTFRAME=11  NUMFRAMES=11

#exec MESHMAP SCALE MESHMAP=macL X=0.1 Y=0.08 Z=0.2

#exec MESHMAP SETTEXTURE MESHMAP=macL NUM=3 TEXTURE=AddHand
#exec MESHMAP SETTEXTURE MESHMAP=macL NUM=2 TEXTURE=AddHand
#exec MESHMAP SETTEXTURE MESHMAP=macL NUM=1 TEXTURE=mac_t2
#exec MESHMAP SETTEXTURE MESHMAP=macL NUM=0 TEXTURE=mac_t1

#exec MESH IMPORT MESH=MACPick ANIVFILE=MODELS\MACPick_a.3D DATAFILE=MODELS\MACPick_d.3D X=0 Y=0 Z=0
#exec MESH ORIGIN MESH=MACPick X=0 Y=0 Z=0 YAW=0 PITCH=0 ROLL=64
#exec MESH SEQUENCE MESH=MACPick SEQ=All     STARTFRAME=0  NUMFRAMES=1
#exec MESHMAP SCALE MESHMAP=MACPick X=0.17 Y=0.17 Z=0.34
#exec MESHMAP SETTEXTURE MESHMAP=macPick NUM=1 TEXTURE=mac_t2
#exec MESHMAP SETTEXTURE MESHMAP=macPick NUM=0 TEXTURE=mac_t1

#exec MESH IMPORT MESH=MACHand ANIVFILE=MODELS\MACHand_a.3D DATAFILE=MODELS\MACHand_d.3D X=0 Y=0 Z=0
#exec MESH ORIGIN MESH=MACHand X=-10 Y=15 Z=-5 YAW=0 PITCH=0
#exec MESH SEQUENCE MESH=MACHand SEQ=All STARTFRAME=0  NUMFRAMES=1
#exec MESH SEQUENCE MESH=MACHand SEQ=Shoot1  STARTFRAME=0  NUMFRAMES=1
#exec MESHMAP SCALE MESHMAP=MACHand X=0.11 Y=0.11 Z=0.22
#exec MESHMAP SETTEXTURE MESHMAP=macHand NUM=1 TEXTURE=mac_t2
#exec MESHMAP SETTEXTURE MESHMAP=macHand NUM=0 TEXTURE=mac_t1

#exec TEXTURE IMPORT NAME=mac10scope FILE=Textures\mac10scope.bmp GROUP="Icons" MIPS=OFF FLAGS=2 LODSET=2

#exec AUDIO IMPORT FILE="Sounds\macfire.wav" NAME="UZIFire"
#exec AUDIO IMPORT FILE="Sounds\macdojezd.wav" NAME="UZI2"

var int Count;
var int shotc;
var int NumFire;
var vector OwnerLocation;
var float StillTime, StillStart;
var float ShotAccuracy, LastShellSpawn;

simulated event RenderOverlays( canvas Canvas )
	{
	local UT_Shellcase s;
	local vector X,Y,Z;
	local float dir;

	FlashY = Default.FlashY * (1.08 - 0.16 * FRand());
	if ( !Owner.IsA('PlayerPawn') || (PlayerPawn(Owner).Handedness == 0) )
		FlashO = Default.FlashO * (4 + 0.15 * FRand());
	else		
		FlashO = Default.FlashO * (1 + 0.15 * FRand());
	Super(TournamentWeapon).RenderOverlays(Canvas);
	}

simulated function PostRender( canvas Canvas )
	{
	local PlayerPawn P;
	local float Scale;

	//	Super.PostRender(Canvas);
	P = PlayerPawn(Owner);
	if ( (P != None) && (P.DesiredFOV != P.DefaultFOV) )
		{
		bOwnsCrossHair = true;
		Scale = Canvas.ClipX/640;
		Canvas.SetPos(0.5 * Canvas.ClipX - 128 * Scale, 0.5 * Canvas.ClipY - 128 * Scale );
		Canvas.Style = ERenderStyle.STY_Translucent;
		Canvas.DrawIcon(Texture'mac10scope', Scale);
		Canvas.SetPos(0.5 * Canvas.ClipX + 64 * Scale, 0.5 * Canvas.ClipY + 96 * Scale);
		// Canvas.DrawColor = 15 * ChallengeHUD(PlayerPawn(Owner).myhud).CrosshairColor;
		// 0xDE9F00
		Canvas.DrawColor.R = 222;
		Canvas.DrawColor.G = 159;
		Canvas.DrawColor.B = 0;
		Scale = P.DefaultFOV/P.DesiredFOV;
		Canvas.DrawText("X"$int(Scale)$"."$int(10 * Scale - 10 * int(Scale)));
		}
	else
		bOwnsCrossHair = false;
	}

function float RateSelf( out int bUseAltMode )
	{
	local float dist;

	if ( AmmoType.AmmoAmount <=0 )
		return -2;
	bUseAltMode = 0;
	if (  Pawn(Owner).Enemy != None )
		{
		dist = VSize(Pawn(Owner).Enemy.Location - Owner.Location);
		if ( dist < 300  )
			{
			return (AIRating + 0.25); 
			}
		}
	return AIRating;
	}

// set which hand is holding weapon
function setHand(float Hand)
	{
	Super.SetHand(Hand);
	if ( Hand == 1 )
		Mesh = mesh(DynamicLoadObject("EMUZIV1.macL", class'Mesh'));
	else
		Mesh = mesh'mac';
	}


function Timer()
	{
	local actor targ;
	local float bestAim, bestDist;
	local vector FireDir;
	local Pawn P;

	bestAim = 0.95;
	P = Pawn(Owner);
	if ( P == None )
		{
		GotoState('');
		return;
		}
	if ( VSize(P.Location - OwnerLocation) < 6 )
		StillTime += FMin(2.0, Level.TimeSeconds - StillStart);
	else
		StillTime = 0;
	StillStart = Level.TimeSeconds;
	OwnerLocation = P.Location;
	FireDir = vector(P.ViewRotation);
	targ = P.PickTarget(bestAim, bestDist, FireDir, Owner.Location);
	if ( Pawn(targ) != None )
		{
		SetTimer(1 + 4 * FRand(), false);
		bPointing = true;
		Pawn(targ).WarnTarget(P, 200, FireDir);
		}
	else 
		{
		SetTimer(0.4 + 1.6 * FRand(), false);
		if ( (P.bFire == 0) && (P.bAltFire == 0) )
			bPointing = false;
		}
	}

function Finish()
	{
	if ( (Pawn(Owner).bFire!=0) && (FRand() < 0.6) )
		Timer();
	Super.Finish();
	}

function TraceFire( float Accuracy )
	{
	local vector HitLocation, HitNormal, StartTrace, EndTrace, X,Y,Z, AimDir;
	local actor Other;
	local Pawn P;

	Accuracy = 0.5;	//makes the uzi inaccurate on long distance, but deadly on short distance.

	P = Pawn(Owner);
	Owner.MakeNoise(P.SoundDampening);
	GetAxes(P.ViewRotation,X,Y,Z);
	StartTrace = Owner.Location + P.Eyeheight * Z;
	AdjustedAim = P.AdjustAim(1000000, StartTrace, 2*AimError, False, False);
	X = vector(AdjustedAim);
	EndTrace = StartTrace + Accuracy * (FRand() - 0.5 )* Y * 1000 + Accuracy * (FRand() - 0.5 ) * Z * 1000;
	AimDir = vector(AdjustedAim);
	EndTrace += (10000 * AimDir);
	Other = P.TraceShot(HitLocation,HitNormal,EndTrace,StartTrace);

	if ( VSize(HitLocation - StartTrace) > 250 )
		Spawn(class'UziTracer',,, StartTrace + 96 * AimDir,rotator(EndTrace - StartTrace));

	ProcessTraceHit(Other, HitLocation, HitNormal, vector(AdjustedAim),Y,Z);
	}

function ProcessTraceHit(Actor Other, Vector HitLocation, Vector HitNormal, Vector X, Vector Y, Vector Z)
	{
	if (Other == Level) 
		Spawn(class'UT_HeavyWallHitEffect',,, HitLocation+HitNormal, Rotator(HitNormal));
	else if ( (Other != self) && (Other != Owner) && (Other != None) )
		{
		if ( Other.bIsPawn )
			{
			Other.PlaySound(Sound 'ChunkHit',, 4.0,,100);
			Other.TakeDamage(10,  Pawn(Owner), HitLocation, 30000.0*X, MyDamageType);
			}

		// added by Mr_Rogers so that carcasses can be violated
		else
			Other.TakeDamage(10,  Pawn(Owner), HitLocation, 30000.0*X, MyDamageType);	

		if ( !Other.bIsPawn && !Other.IsA('Carcass') )
			spawn(class'UT_SpriteSmokePuff',,,HitLocation+HitNormal*9);
		}
	}

/////////////////////////////////////////////////////////////////////
state ClientFiring
	{
	simulated function bool ClientFire(float Value)
		{
		return false;
		}
	simulated function bool ClientAltFire(float Value)
		{
		return false;
		}
	simulated function AnimEnd()
		{
		// recoil
		// CSHP considers this to be a Rouge aimbot (Mr_Rogers, 1/4/05)
//		Pawn(Owner).ViewRotation.Pitch += (shotc * 5);
		shotc++;
		if ( (Pawn(Owner) == None) || ((AmmoType != None) && (AmmoType.AmmoAmount <= 0)) )
			{
			PlayIdleAnim();
			GotoState('');
			}
		else if ( !bCanClientFire )
			GotoState('');
		else if ( Pawn(Owner).bFire != 0 )
			Global.ClientFire(0);
		else if ( Pawn(Owner).bAltFire != 0 )
			Global.ClientAltFire(0);
		else
			{
			PlayIdleAnim();
			GotoState('');
			}
		}
	simulated function EndState()
		{
		AmbientSound = None;
		}
	}

////////////////////////////////////////////////////////////////////////////
state NormalFire
	{
	function Tick( float DeltaTime )
		{
		if (Owner==None) 
			AmbientSound = None;
		}
	function AnimEnd()
		{
		}
	function BeginState()
		{
		}	
	function EndState()
		{
		bSteadyFlash3rd = False;
		Super.EndState();
		OldFlashCount = FlashCount;
		}
	Begin:
	PlayFiring();
	bMuzzleflash++;
	Tracefire(0.0);
	AimError = Default.AimError;
	FinishAnim();
	Finish();
	}

////////////////////////////////////////////////////////////////////////////////
state Idle
	{
	function Fire( float Value )
		{
		if ( AmmoType == None )
			{
			// ammocheck
			GiveAmmo(Pawn(Owner));
			}
		if (AmmoType.UseAmmo(1))
			{
			GotoState('NormalFire');
			bCanClientFire = true;
			bPointing=True;
			if ( Owner.IsA('Bot') )
				{
				// simulate bot using zoom
				if ( Bot(Owner).bSniping && (FRand() < 0.65) )
					AimError = AimError/FClamp(StillTime, 1.0, 8.0);
				else if ( VSize(Owner.Location - OwnerLocation) < 6 )
					AimError = AimError/FClamp(0.5 * StillTime, 1.0, 3.0);
				else
					StillTime = 0;
				}
			Pawn(Owner).PlayRecoil(FiringSpeed);
			TraceFire(0.0);
			AimError = Default.AimError;
			ClientFire(Value);
			}
		}
	function BeginState()
		{
		bPointing = false;
		SetTimer(0.4 + 1.6 * FRand(), false);
		Super.BeginState();
		}
	function EndState()
		{	
		bSteadyFlash3rd = False;
		SetTimer(0.0, false);
		Super.EndState();
		}
	Begin:
	bPointing=False;
	if ( AmmoType.AmmoAmount<=0 ) 
		Pawn(Owner).SwitchToBestWeapon();  //Goto Weapon that has Ammo
	if ( Pawn(Owner).bFire!=0 )
		Fire(0.0);
	Disable('AnimEnd');
	PlayIdleAnim();
	}

simulated function bool ClientAltFire( float Value )
	{
	GotoState('Zooming');
	return true;
	}

function AltFire( float Value )
	{
	ClientAltFire(Value);
	}

Simulated function PlayFiring()
	{
	local int r;

	PlayOwnedSound(FireSound, SLOT_None, Pawn(Owner).SoundDampening*3.0);
	bSteadyFlash3rd = True;
	// PlayAnim('fire',0.5 + 0.5 *(FireAdjust*16.0), 0.05);
	PlayAnim('fire',0.5+0.5*(FireAdjust*4.0),0.05);
	if (PlayerPawn(Owner) != None)
		bMuzzleFlash++;
	}

///////////////////////////////////////////////////////////////////////////////////
state Zooming
	{
	simulated function Tick(float DeltaTime)
		{
		if ( Pawn(Owner).bAltFire == 0 )
			{
			if ( (PlayerPawn(Owner) != None) && PlayerPawn(Owner).Player.IsA('ViewPort') )
				PlayerPawn(Owner).StopZoom();
			SetTimer(0.0,False);
			GoToState('Idle');
			}
		}
	simulated function BeginState()
		{
		if ( Owner.IsA('PlayerPawn') )
			{
			if ( PlayerPawn(Owner).Player.IsA('ViewPort') )
				PlayerPawn(Owner).ToggleZoom();
			SetTimer(0.2,True);
			}
		else
			{
			Pawn(Owner).bFire = 1;
			Pawn(Owner).bAltFire = 0;
			Global.Fire(0);
			}
		}
	}

////////////////////////////////////////////////////////////////////////
simulated function PlayIdleAnim()
	{
	if ( Mesh != PickupViewMesh )
		{		
		PlayAnim('Still',1.0, 0.05);
		}
	shotc=0;
	bSteadyFlash3rd = False;
	}

defaultproperties
{
    WeaponDescription="Classification: UZI"
    AmmoName=Class'US_Ammo'
    PickupAmmoCount=100
    bInstantHit=True
    bAltInstantHit=True
    FireOffset=(X=8.00,Y=-5.00,Z=-4.00),
    AltDamageType=shot
    shakemag=350.00
    shaketime=0.15
    shakevert=8.00
    AIRating=0.53
    RefireRate=0.99
    AltRefireRate=0.99
    FireSound=Sound'UZIFire'
    SelectSound=Sound'UnrealI.Rifle.RiflePickup'
    Misc1Sound=Sound'Botpack.enforcer.Reload'
    Misc2Sound=Sound'Botpack.enforcer.Reload'
    Misc3Sound=Sound'UZI2'
    DeathMessage="%k's %w just turned %o into a swizz cheese."
    NameColor=(R=255,G=255,B=0,A=0),
    bDrawMuzzleFlash=True
    MuzzleScale=2.00
    FlashY=0.18
    FlashO=0.02
    FlashC=0.01
    FlashLength=0.20
    FlashS=128
    MFTexture=Texture'Botpack.Skins.Muz9'
    AutoSwitchPriority=5
    InventoryGroup=9
    bRotatingPickup=False
    PickupMessage="You got the UZI"
    ItemName="MadMan's UZI"
    PlayerViewOffset=(X=12.00,Y=-7.00,Z=-8.00),
    PlayerViewMesh=LodMesh'mac'
    PlayerViewScale=0.60
    BobDamping=0.98
    PickupViewMesh=LodMesh'MACPick'
    ThirdPersonMesh=LodMesh'MACHand'
    StatusIcon=Texture'Botpack.Icons.UseMini'
    bMuzzleFlashParticles=True
    MuzzleFlashStyle=3
    MuzzleFlashMesh=LodMesh'Botpack.MuzzFlash3'
    MuzzleFlashScale=0.25
    MuzzleFlashTexture=Texture'Botpack.Skins.Muzzy'
    PickupSound=Sound'UnrealShare.Pickups.WeaponPickup'
    Icon=Texture'Botpack.Icons.UseMini'
    Mesh=LodMesh'mac'
    bNoSmooth=False
    SoundRadius=96
    SoundVolume=255
    CollisionRadius=15.00
    CollisionHeight=5.00
    LightEffect=13
    LightBrightness=255
    LightHue=28
    LightSaturation=32
    LightRadius=12
    Mass=15.00
    HUDname="Uzi"
    HUDcolor=(R=255,G=255,B=0)
}
